#!/usr/bin/env node
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var getImportMetaUrl = () => typeof document === "undefined" ? new URL("file:" + __filename).href : document.currentScript && document.currentScript.src || new URL("main.js", document.baseURI).href;
var importMetaUrl = /* @__PURE__ */ getImportMetaUrl();
var import_node_path = __toESM(require("node:path"));
var import_node_child_process = require("node:child_process");
var import_commander = require("commander");
var import_index = require("./index.js");
const templateCJSPath = import_node_path.default.resolve(__dirname, "../../templates/template.ejs");
const templateESMPath = new URL("../templates/template.ejs", importMetaUrl).pathname;
import_commander.program.option("-o, --output [output]", "output file", "yarn-audit.html").option("-t, --template [ejs file]", "ejs template file", global.__dirname ? templateCJSPath : templateESMPath).option("--fatal-exit-code", "exit with code 1 if vulnerabilities were found", false).parse();
console.info("Checking audit logs...");
let summary;
const options = import_commander.program.opts();
const vulnerabilities = /* @__PURE__ */ new Map();
const { stdout } = (0, import_node_child_process.spawnSync)("yarn", ["--version"]);
const yarnMajorVersion = Number.parseInt(stdout.toString());
let text = "";
process.stdin.on("readable", function() {
  try {
    const chunk = this.read();
    if (chunk !== null) {
      text += chunk;
      const lines = text.split("\n");
      if (lines.length > 1) {
        let advisoryToVulnerabilities2 = function(advisory) {
          const newVulnerabilities = (0, import_index.parseAdvisory)(advisory);
          newVulnerabilities.forEach((newVulnerability) => {
            const { key } = newVulnerability;
            if (!vulnerabilities.has(key)) {
              vulnerabilities.set(key, newVulnerability);
            }
          });
        };
        var advisoryToVulnerabilities = advisoryToVulnerabilities2;
        text = lines.splice(-1, 1)[0];
        lines.forEach((line) => {
          if (yarnMajorVersion >= 2) {
            const auditAdvisoryData = JSON.parse(line);
            Object.values(auditAdvisoryData.advisories).forEach((rawAdvisory) => {
              advisoryToVulnerabilities2(rawAdvisory);
            });
            summary = auditAdvisoryData.metadata;
          } else {
            const auditAdvisoryData = JSON.parse(line);
            if (auditAdvisoryData.type === "auditAdvisory") {
              advisoryToVulnerabilities2(auditAdvisoryData.data.advisory);
            } else if (auditAdvisoryData.type === "auditSummary") {
              summary = auditAdvisoryData.data;
            }
          }
        });
      }
    }
  } catch (error) {
    (0, import_index.bailWithError)("Failed to parse YARN Audit JSON!", error, options.fatalExitCode);
  }
});
process.stdin.on("end", async function() {
  try {
    await (0, import_index.generateReport)(Array.from(vulnerabilities.values()), summary, options);
  } catch (error) {
    (0, import_index.bailWithError)(
      "Failed to generate report! Please report this issue to https://github.com/davityavryan/yarn-audit-html/issues",
      error,
      options.fatalExitCode
    );
  }
});
